// Defines from Sparta-Mod

// TASK's
#define TASK_STRIP 0
#define TASK_BOMB 32
#define TASK_SPEED 64
#define TASK_LIGHTNINGNEXT 96
#define TASK_LIGHTNING 128
#define TASK_GIVEDEFUSE 160
#define TASK_GLOBALULT 193
#define TASK_CONNECT_XP 225
#define TASK_ULT_FLASH 257
#define TASK_ULT_SOUND 289
#define TASK_ULT_BLAST 321
#define TASK_ULT_NAPALM 353
#define TASK_ULTIMATE 385
#define TASK_SET_ULT 417
#define TASK_ULT_EXPLODE 449
#define TASK_ULT_IMP 481
#define TASK_ULT_CIRCLES 513
#define TASK_SHIELD 545
#define TASK_SHOCK 577
#define TASK_SILENCE 609
#define TASK_NADE 641
#define TASK_POISON 673

// Default maximum damage with this mod
#define DEFAULT_DAMAGE 65.0

// Nvault
#define NVAULT_FILE "spartamod"

// What kind of Saveby
#define XP_SAVEBY_ID 0
#define XP_SAVEBY_IP 1
#define XP_SAVEBY_NAME 2

// Other stuff
#define MAX_PLAYERS 33
#define SPARTA_NAME "[SPARTA]"

// Level's
#define MAX_LEVEL 50

// Knife's
#define MAX_KNIFES 10

// XP's
#define XP_FOR_LEVEL 5000

// Default Speed
#define DEFAULT_SPEED 250.0

// XP Roles
#define PLR_NOTHING     0
#define PLR_BOMBCARRIER 1
#define PLR_BOMBDEFUSER 2
#define PLR_BOMBPLANTER 3
#define PLR_HOSTRESCUER 4
#define PLR_VIP		5

// Team Defs
#define TEAM_T 1
#define TEAM_CT 2

// Generel ultimates. 0 = None!
#define MAX_ULTIMATES 5

// The player get moved in the air. How high?
#define ULTIMATE_HIGH 300.0

// None Ultimate
#define ULTIMATE_NONE 0

// Ultimate 1 Defines
#define ULTIMATE_FLASH 1
#define BW_RADIUS 400
#define BW_POWER 600
#define BW_DMG 30

// Ultimate 2 Defines
#define ULTIMATE_BLAST 2
#define AF_RADIUS 400
#define AF_TIME 4

// Ultimate 3 Defines
#define ULTIMATE_NAPALM 3
#define NA_RADIUS 400
#define NA_DAMAGE 80

// Ultimate 4 Defines
#define ULTIMATE_LIGHTNING 4
#define CHAINLIGHTNING_DAMAGE 50		// Initial ultimate damage
#define CHAINLIGHTNING_LINEWIDTH 80		// Width of the lightning sprite
#define LIGHTNING_RANGE	500			// The range...
#define LIGHTNINGHIT 2
#define ISSEARCHING 3

// Sprites & Sounds
#define MAX_SPRITES 5

#define EXPLOSION_SPRITE 0
#define SMOKE_SPRITE 1
#define SHOCKWAVE_SPRITE 2
#define LIGHTNING_SPRITE 3
#define TRAIL_SPRITE 4

#define PAIN_SOUND 0
#define THIS_IS_SPARTA_SOUND 1
#define FLASHBANG_SOUND 2
#define EXPLOSION_SOUND 3
#define LEVELUP_SOUND 4
#define ULTREADY_SOUND 5
#define BOMBDEFUSED_SOUND 6
#define EVENT_SOUND 7
#define LIGHTNING_SOUND 8
#define ULTIMATESCAN_SOUND 9
#define IMPALE_SOUND 10
#define BANISH_SOUND 11
#define POISON_SOUND 12

// Skill general defines
#define MAX_SKILLS 7
#define MAX_SKILLS_ONSIDE 8

#define SKILL_SIDE 0
#define AVAILABLE_SKILLS 1

#define SKILL_LEVITATION 0
#define SKILL_INVISIBLE 1
#define SKILL_SPEED 2
#define SKILL_HEALTH 3
#define SKILL_CRITICAL 4
#define SKILL_SHOCKING 5
#define SKILL_SILENCE 6

// Skills defines
#define HEALTH_FOR_SKILL 15
#define LEVITATION_FOR_SKILL 44
#define SPEED_FOR_SKILL 20
#define SHOCKING_TOUCH_CHANCE 0.15
#define SILENCE_CHANCE 0.15
#define DEFAULT_SILENCE_TIME 5.0 // 5 seconds

// 25% crit chance
#define CRITICAL_STRIKE_CHANCE 0.25 	

// Utilmenu defs
#define MAX_UTILONE_ITEMS 5
#define UTILMENU_ONE 0
#define NADE_MULTI 0.2 // 20% more damage for evey nade level
#define POISON_CHANCE 0.15 // 15% chance to infect the enemy

#define ITEM_NONE 0
#define ITEM_REINCARNATION 1
#define ITEM_NADEONE 2
#define ITEM_NADETWO 3
#define ITEM_NADETHREE 4
#define ITEM_SLOWDOWN 5

// The names of the items
new const Util_One_Items[MAX_UTILONE_ITEMS][] = {
	"Reincarnation",
	"Hegrenade lvl 1",
	"Hegrenade lvl 2",
	"Hegrenade lvl 3",
	"Slowdown Poison"
}

new const Util_One_Cost[MAX_UTILONE_ITEMS] = { 4000, 3000, 6000, 9000, 3500 } // Reincarnation cost 4000$...

new const Skill_Invis[8] = { 175, 160, 145, 130, 115, 100, 87, 67 } // Invisibility
new const Skill_Critical[8] = { 2, 5, 8, 15, 20, 25, 28, 35 } // Critical Damage

// Skill names
new const Skill_Names[][] = {
	"Levitation",
	"Invisibility",
	"Speed",
	"Health",
	"Critical Strike",
	"Shocking Touch",
	"Silence"
}

// Skill level's
new const Skill_REQLevel[MAX_SKILLS] = { 1, 5, 15, 20, 12, 25, 30 } // Levitation required lvl 1, Invisible required lvl 5...

// Player can skill a skilltype by the maximum
new const Skill_Max_Point[MAX_SKILLS] = { 10, 8, 8, 10, 8, 1, 3 } // Levitation maximum skill 10, Invisible maximum skill 8...

// Ultimate names 
new const Ultimate_Names[][] = {
	"None",
	"Air Flash",
	"Blast Wave",
	"Napalm Attack",
	"Chainlightning"
}

// Ultimate level's
new const Ultimate_REQLevel[MAX_ULTIMATES] = { 0, 10, 20, 30, 40 } // Ultimate 1 required lvl 10, Ultimate 2 required lvl 20...

// Level knife models
new const g_knifes[][] = {
	"models/sparta/sp_level1.mdl",
	"models/sparta/sp_level2.mdl",
	"models/sparta/sp_level3.mdl",
	"models/sparta/sp_level4.mdl",
	"models/sparta/sp_level5.mdl",
	"models/sparta/sp_level6.mdl",
	"models/sparta/sp_level7.mdl",
	"models/sparta/sp_level8.mdl",
	"models/sparta/sp_level9.mdl",
	"models/sparta/sp_level10.mdl"
}

// Sounds
new const g_Sound[][] = {
	"player/pl_pain2.wav",
	"sparta/this_is_sparta.wav",
	"weapons/flashbang-1.wav",
	"ambience/particle_suck1.wav",
	"sparta/levelupcaster.wav",
	"sparta/resurrecttarget.wav",
	"sparta/bombdefused.wav",
	"sparta/event.wav",
	"sparta/lightningbolt.wav",
	"turret/tu_ping.wav",
	"sparta/impalehit.wav",
	"sparta/banishcaster.wav",
	"sparta/carrionswarmlaunch1.wav"
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1031\\ f0\\ fs16 \n\\ par }
*/
