// Sparta-Mod Event's

// The round is over
public RoundEnd()
{
	if ( !get_pcvar_num( sparta_mod_on ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	// The round is over
	g_RoundOver = true;
	
	// The player with the bomb should get xps for the next round
	g_PlayerSpawnBomb = 0;
	
	return PLUGIN_CONTINUE;
}

// The round starts
public RoundStart()
{
	if ( !get_pcvar_num( sparta_mod_on ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	new i, players[32], num;
	get_players ( players, num );
	
	// Nobody defused or planted THIS round and nobody is in a ultimate
	for ( i = 0; i < num; ++i )
	{
		g_PlantOrDefuse[players[i]] = false;
	}
	
	// Set up the task if it not exists
	if ( !task_exists( TASK_GLOBALULT ) )
	{
		set_task ( 1.0, "CheckUlt", TASK_GLOBALULT, "", 0, "b" );
	}
	
	return PLUGIN_CONTINUE;
}

// Terrorist's win
public on_TerroristWin()
{
	GiveTeamXP( TEAM_T );
}

// Counterterrorist' win
public on_CTWin()
{
	GiveTeamXP( TEAM_CT );
}

// This called on a new round. The round isn't started because the freezetime is not over 
public NewRound()
{
	// Set the var
	g_FreezeTimeOver = false;
	
	// The round starts
	g_RoundOver = false;
}

// The player spawned
public Set_User_Abilities( id )
{
	if ( !is_user_alive( id ) )
	{
		return HAM_IGNORED;
	}
	
	// A player can't be level 0
	if ( Player_Level[id] <= 0 )
	{
		Player_Level[id] = 1;
	}
	
	// Show him the bar
	PlayerShowBar( id );
	
	// Set the skills for the player if he has some
	Update_Skills( id );
	
	// Ultimates important. Select one!
	if ( Player_Ultimate[id] == 0 && Player_Level[id] >= Ultimate_REQLevel[1] && !is_user_bot( id ) )
	{
		set_task ( 0.4, "SelectUltimate", ( TASK_SET_ULT + id ) );
	}
	
	// Has the player an available skillpoint and has he not all skilled?
	if ( Player_SkillData[id][AVAILABLE_SKILLS] > 0 && !is_user_bot( id ) && !FullSkilled( id ) )
	{
		// Show the menu with the first (0) side
		ChooseSkill( id, 0 );
	}
	
	// Give him a defusekit if he is a ct
	if ( get_user_team( id ) == TEAM_CT && !task_exists( id + TASK_GIVEDEFUSE ) )
	{
		set_task ( 2.5, "GivePlayerDefuse", ( id + TASK_GIVEDEFUSE ) );
	}
	
	return HAM_HANDLED;
}

// Freeze time is over
public on_FreezeTimeComplete()
{
	// The freezetime is over (need it to set the speed)
	g_FreezeTimeOver = true;
	
	// Let us set the speed and their ultimate cooldowns back
	static num, players[32], i;
	get_players ( players, num );
		
	// Show a hudmessage to all
	doTypesay ( "Prepare for Glory!", 3, 210, 0, 0, 1, 3.0, 0);
	
	for ( i = 0; i < num; ++i )
	{
		if ( is_user_alive( players[i] ) )
		{
			if ( Player_Ultimate[players[i]] != ULTIMATE_NONE )
			{
				// The ultimate is now ready
				UltReady( players[i] );
			}
			
			// set the speed
			if ( Player_Skill[players[i]][SKILL_SPEED] > 0 )
			{
				set_task( 0.2, "Skill_SetSpeed", ( TASK_SPEED + players[i] ) );
			}
		}
	}
}

// A player died
public PlayerDied( id, idattacker )
{
	// victim and killer are connected?
	if ( !is_user_connected( id ) || !is_user_connected( idattacker ) )
	{
		return PLUGIN_CONTINUE;
	}
		
	static XPs, TempResult;
	
	// Check ultimate icon
	HandleIcon( id, 0 );
	
	// Get the XPs from the CVAR
	XPs = get_pcvar_num( sp_kill );
	
	// Now we handle how many xps the player get/lose by the level from the victim
	static TempLevel;
	TempLevel = Player_Level[id];
	
	// We get the difference between the two players
	TempLevel -= Player_Level[idattacker];
	
	// The attacker is lower as the victim. He get extra xps
	if ( TempLevel > 1 )
	{
		XPs = TempLevel * XPs;
	}
	
	// is the killer a Teamkiller?
	if ( get_user_team( id ) == get_user_team( idattacker ) )
	{
		// Take the xps from the Array and save the result
		TempResult = TakePlayerXP( idattacker, XPs );
		
		// We shouldn't write a Message
		if ( !TempResult ) 
		{
			return HAM_IGNORED;
		}
		
		client_print ( idattacker, print_chat, "%s You have lost %d XP for killing a teammate", SPARTA_NAME, XPs );
		
		return PLUGIN_CONTINUE;
	}
	
	// The round is actually over. But he should get xps
	g_GiveEndRoundXP = true;
	
	// Add the xps to the Array 
	TempResult = GivePlayerXP( idattacker, XPs );
	
	// We shouldn't write a message
	if ( !TempResult )
	{
		return PLUGIN_CONTINUE;
	}
	
	// Message to the Killer
	static dead_name[32];
	get_user_name ( id, dead_name, charsmax( dead_name ) );
	
	// Send the player a Message
	client_print ( idattacker, print_chat, "%s You have been awarded %d XP for killing the enemy %s", SPARTA_NAME, XPs, dead_name );
		
	// Message to the dead player
	static killer_name[32];
	get_user_name ( idattacker, killer_name, charsmax( killer_name ) );
	
	// Send the player a Message
	client_print ( id, print_chat, "%s You got owned by %s", SPARTA_NAME, killer_name );
	
	// -------------------------------- Extra XPs for a important kill --------------------------------
	
	// XPs for the killer
	XPs = get_pcvar_num( sp_rolekill );
	
	// The round is actually over. But he should get xps
	g_GiveEndRoundXP = true;
	
	// The victim was the bomb carrier
	if ( g_PlayerRole[id] == PLR_BOMBCARRIER )
	{
		// Add the xps to the Array
		TempResult = GivePlayerXP( idattacker, XPs );
		
		if ( TempResult )
		{
			// Send the message to the killer
			client_print( idattacker, print_chat, "%s You have been awarded %d XP for killing the bomb carrier", SPARTA_NAME, XPs );
		}
	}
	
	// The victim was planting the bomb
	else if ( g_PlayerRole[id] == PLR_BOMBPLANTER )
	{
		// Add the xps to the Array
		TempResult = GivePlayerXP( idattacker, XPs );
		
		if ( TempResult )
		{
			// Send the message to the killer
			client_print( idattacker, print_chat, "%s You have been awarded %d XP for killing the bomb planter", SPARTA_NAME, XPs );
		}
	}
	
	//  The victim was defusing the bomb
	else if ( g_PlayerRole[id] == PLR_BOMBDEFUSER )
	{
		// Add the xps to the Array
		TempResult = GivePlayerXP( idattacker, XPs );
		
		if ( TempResult )
		{
			// Send the message to the killer
			client_print( idattacker, print_chat, "%s You have been awarded %d XP for killing the bomb defuser", SPARTA_NAME, XPs );
		}
	}
	
	// The victim was rescuing a hostage
	else if ( g_PlayerRole[id] == PLR_HOSTRESCUER )
	{
		// Add the xps to the Array
		TempResult = GivePlayerXP( idattacker, XPs );
		
		if ( TempResult )
		{
			// Send the message to the killer
			client_print( idattacker, print_chat, "%s You have been awarded %d XP for killing the hostage rescuer", SPARTA_NAME, XPs );
		}
	}
	
	// The victim was the vip
	else if ( g_PlayerRole[id] == PLR_VIP )
	{
		// Add the xps to the Array
		TempResult = GivePlayerXP( idattacker, XPs );
		
		if ( TempResult )
		{
			// Send the message to the killer
			client_print( idattacker, print_chat, "%s You have been awarded %d XP for killing the VIP", SPARTA_NAME, XPs );
		}
	}
	
	// The victim is dead, let us reset the data
	g_PlayerRole[id] = PLR_NOTHING;
	
	return PLUGIN_CONTINUE;
}

// Called if someone starts to planting the bomb
public bomb_planting( id )
{
	if ( !get_pcvar_num( sparta_mod_on ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	if ( !is_user_connected( id ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	// Only once per round
	if ( g_PlantOrDefuse[id] )
	{
		return PLUGIN_CONTINUE;
	}
	
	else
	{
		g_PlantOrDefuse[id] = true;
	}
	
	// Set him as Bomb planter
	g_PlayerRole[id] = PLR_BOMBPLANTER;
	
	// get the XPs from the CVAR
	static XPs, TempResult;
	XPs = get_pcvar_num( sp_bombplanting );
	
	TempResult = GivePlayerXP( id, XPs );
	
	if ( !TempResult )
	{
		return PLUGIN_CONTINUE;
	}
	
	client_print ( id, print_chat, "%s You have been awarded %d XP for starting to plant the bomb", SPARTA_NAME, XPs );
	
	return PLUGIN_CONTINUE;
}

// Called if someone starts to defusing the bomb
public bomb_defusing( id )
{
	if ( !get_pcvar_num( sparta_mod_on ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	if ( !is_user_connected( id ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	// Only once per round
	if ( g_PlantOrDefuse[id] )
	{
		return PLUGIN_CONTINUE;
	}
	
	else
	{
		g_PlantOrDefuse[id] = true;
	}
	
	// Set him as Bomb defuser
	g_PlayerRole[id] = PLR_BOMBDEFUSER;
	
	// get the XPs from the CVAR
	static XPs, TempResult;
	XPs = get_pcvar_num( sp_bombdefusing );
	
	TempResult = GivePlayerXP( id, XPs );
	
	if ( !TempResult )
	{
		return PLUGIN_CONTINUE;
	}
	
	client_print ( id, print_chat, "%s You have been awarded %d XP for starting to defuse the bomb", SPARTA_NAME, XPs );
	
	return PLUGIN_CONTINUE;
}
	
// Someone planted the bomb
public bomb_planted( id )
{
	if ( !get_pcvar_num( sparta_mod_on ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	if ( !is_user_connected( id ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	// Get the XPs from the CVAR
	static XPs, TempResult;
	XPs = get_pcvar_num( sp_planting );
	
	// No more Bomb carrier
	g_PlayerRole[id] = PLR_NOTHING;
	
	// Add the xps to the Array 
	TempResult = GivePlayerXP( id, XPs );
	
	if ( !TempResult )
	{
		return PLUGIN_CONTINUE;
	}
	
	// Play a sound
	if ( get_pcvar_num( sp_soundon ) )
	{
		client_cmd ( 0, "speak %s", g_Sound[EVENT_SOUND] );
	}
	
	// Send the player a message
	client_print ( id, print_chat, "%s You have been awarded %d XP for planting the bomb", SPARTA_NAME, XPs );
	
	return PLUGIN_CONTINUE;
}

// Someone has defused the bomb
public bomb_defused( id )
{
	if ( !get_pcvar_num( sparta_mod_on ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	if ( !is_user_connected( id ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	// Get the XPs from the CVAR
	static XPs, TempResult;
	XPs = get_pcvar_num( sp_defusing );
	
	// The round is actually over. But he should get xps
	g_GiveEndRoundXP = true;
	
	// Add the xps to the Array
	TempResult = GivePlayerXP( id, XPs );
	
	if ( !TempResult )
	{
		return PLUGIN_CONTINUE;
	}
	
	// Send the player a Message
	client_print ( id, print_chat, "%s You have been awarded %d XP for defusing the bomb", SPARTA_NAME, XPs );
	
	// Play a sound
	if ( get_pcvar_num( sp_soundon ) )
	{
		client_cmd ( 0, "speak %s", g_Sound[BOMBDEFUSED_SOUND] );
	}
	
	return PLUGIN_CONTINUE;
}

// Some player actions (From wc3ft)
public on_PlayerAction()
{
	if ( !get_pcvar_num( sparta_mod_on ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	new sArg[64], sAction[64], sName[64];
	new iUserId, id;

	read_logargv ( 0, sArg, charsmax( sArg ) );
	read_logargv ( 2, sAction, charsmax( sAction ) );
	parse_loguser ( sArg, sName, charsmax( sName ), iUserId );
	id = find_player ( "k", iUserId );
	
	if ( id == 0 )
	{
		return PLUGIN_CONTINUE;
	}
	
	static XPs, TempResult;
	
	// Dropped bomb 
	if ( equal(sAction, "Dropped_The_Bomb" ) )
	{
		// Get the right XPs
		XPs = get_pcvar_num( sp_dropbomb );
		
		// He isn't no more Bombcarrier
		g_PlayerRole[id] = PLR_NOTHING;
		
		// Take the xps from the Array and save the result
		TempResult = TakePlayerXP( id, XPs );
		
		// We shouldn't write a message
		if ( !TempResult )
		{
			return PLUGIN_CONTINUE;
		}
		
		// Send the player a Message
		client_print( id, print_chat, "%s You have lost %d XP for dropping the bomb", SPARTA_NAME, XPs );
	}
	
	// Picked up bomb 
	else if ( equal( sAction, "Got_The_Bomb" ) )
	{ 
		// Get the right XPs
		XPs = get_pcvar_num( sp_pickbomb );
		
		// Set him as Bomb carrier
		g_PlayerRole[id] = PLR_BOMBCARRIER;
		
		// Add the xps to the Array 
		TempResult = GivePlayerXP( id, XPs );
		
		if ( !TempResult )
		{
			return PLUGIN_CONTINUE;
		}
		
		// Send the player a Message
		client_print( id, print_chat, "%s You have been awarded %d XP for picking up the bomb", SPARTA_NAME, XPs );
	}
	
	// Hostage touched 
	else if ( equal( sAction, "Touched_A_Hostage" ) )
	{
		// Get the right XPs
		XPs = get_pcvar_num( sp_follhost );
		
		// Set him as Hostage rescuer
		g_PlayerRole[id] = PLR_HOSTRESCUER;
		
		// Add the xps to the Array 
		TempResult = GivePlayerXP( id, XPs );
		
		if ( !TempResult )
		{
			return PLUGIN_CONTINUE;
		}
		
		// Send the player a Message
		client_print( id, print_chat, "%s You have been awarded %d XP for starting to rescue a hostage", SPARTA_NAME, XPs );
	}
	
	// Hostage rescued 
	else if ( equal( sAction, "Rescued_A_Hostage" ) )
	{
		// Get the right XPs
		XPs = get_pcvar_num( sp_rescuehost );
		
		// No more rescuer
		g_PlayerRole[id] = PLR_NOTHING;
		
		// Add the xps to the Array 
		TempResult = GivePlayerXP( id, XPs );
		
		if ( !TempResult )
		{
			return PLUGIN_CONTINUE;
		}
		
		// Send the player a Message
		client_print( id, print_chat, "%s You have been awarded %d XP for rescuing a hostage", SPARTA_NAME, XPs );
	}
	
	// Hostage killed 
	else if ( equal( sAction, "Killed_A_Hostage" ) )
	{
		// Get the right XPs
		XPs = get_pcvar_num( sp_killhost );
		
		// Take the xps from the Array and save the result
		TempResult = TakePlayerXP( id, XPs );
		
		// We shouldn't write a message
		if ( !TempResult )
		{
			return PLUGIN_CONTINUE;
		}
		
		// Send the player a Message
		client_print( id, print_chat, "%s You have lost %d XP for killing a hostage", SPARTA_NAME, XPs );
	}
	
	// VIP spawn 
	else if ( equal( sAction, "Became_VIP" ) )
	{ 
		// Get the right XPs
		XPs = get_pcvar_num( sp_gotvip );
		
		// Set him as Vip-Role
		g_PlayerRole[id] = PLR_VIP;
		
		// Add the xps to the Array
		g_GiveEndRoundXP = true;
		TempResult = GivePlayerXP( id, XPs );
		
		if ( !TempResult )
		{
			return PLUGIN_CONTINUE;
		}
		
		// Send the player a Message
		client_print( id, print_chat, "%s You have gained %d XP for spawning as the VIP", SPARTA_NAME, XPs );
	}
	
	// VIP escaped 
	else if ( equal( sAction, "Escaped_As_VIP" ) )
	{
		// Get the right XPs
		XPs = get_pcvar_num( sp_escvip );
		
		// No more VIP
		g_PlayerRole[id] = PLR_NOTHING;
		
		// Add the xps to the Array 
		TempResult = GivePlayerXP( id, XPs );
		
		if ( !TempResult )
		{
			return PLUGIN_CONTINUE;
		}
		
		// Send the player a Message
		client_print( id, print_chat, "%s You have gained %d XP for escaping as the VIP", SPARTA_NAME, XPs );
	}
	
	return PLUGIN_CONTINUE;
}

// A player get damage
public PlayerGetDamage( idvictim, weapon, idattacker, Float:health )
{
	if ( !get_pcvar_num( sparta_mod_on ) )
	{
		return HAM_IGNORED;
	}
	
	// No dmg multiplier for suiciders
	if ( idvictim == idattacker )
	{
		return HAM_IGNORED;
	}
	
	if ( !is_user_connected( idvictim ) || !is_user_connected( idattacker ) )
	{
		return HAM_IGNORED;
	}
	
	// This function will called if player shoot at another player. Also if friendlyfire is off
	if ( get_cvar_num( "mp_friendlyfire" ) == 0 && get_user_team( idvictim ) == get_user_team( idattacker ) )
	{
		return HAM_IGNORED;
	}
	
	// CS knife damage is to hard for us. No fun... we set it lower!
	if ( health > DEFAULT_DAMAGE )
	{
		health = DEFAULT_DAMAGE;
	}
	
	// Check if it's a critical strike
	health = Skill_CriticalStrike( idattacker, idvictim, health );
	
	// Check if this hit activated shocking touch
	Skill_ShockingTouch( idattacker, idvictim );
	
	// Check if this hit activated silence
	Skill_Silence( idattacker, idvictim );
	
	// Check if the player has Slowdown Poison
	ITEM_SlowDownPoison( idattacker, idvictim );
	
	// Beginner's luck
	if ( get_pcvar_num( sp_beginnersluck ) && Player_Level[idvictim] <= get_pcvar_num( sp_beginnerslevel ) )
	{
		static Float:LostDmg;
		LostDmg = random_float( 0.0, get_pcvar_float( sp_beginnersdmg ) );
		
		health -= LostDmg;
		if ( health <= 0.0 )
		{
			client_print ( idattacker, print_chat, "%s The enemy evaded your attack completely", SPARTA_NAME );
			client_print ( idvictim, print_chat, "%s You have evaded the attack from the enemy completely", SPARTA_NAME );
		}
	}
	
	// The weapon was a nade!
	if ( IsGrenade ( weapon ) )
	{
		// We calculate the new damage
		health += float( Player_ItemData[idattacker][UTILMENU_ONE] - 1 ) * ( health * NADE_MULTI );
		
		// He has no more a hegrenade
		Player_ItemData[idattacker][UTILMENU_ONE] = ITEM_NONE;
		
		// we need later this information
		weapon = 3;
	}
	
	// It was not a hegrenade
	else
	{
		weapon = 0;
	}
	
	if ( health > 1.0 )
	{
		// Hook the default damage and insert our new damage
		DoDamageToPlayer( idattacker, idvictim, floatround( health ), 0, weapon );
	}
	
	return HAM_SUPERCEDE;
}

// Called when a player looks at another player
public TRIGGER_TraceLine( Float:v1[3], Float:v2[3], noMonsters, pentToSkip )
{
	if ( !get_pcvar_num( sparta_mod_on ) )
	{
		return FMRES_IGNORED;
	}
	
	new iAttacker = pentToSkip;
	new iVictim = get_tr(TR_pHit);
	
	// Is the attacker valid?
	if ( iAttacker < 0 || iAttacker > MAX_PLAYERS )
	{
		return FMRES_IGNORED;
	}
	
	// is the victim valid?
	else if ( iVictim < 0 || iVictim > MAX_PLAYERS )
	{
		return FMRES_IGNORED;
	}
	
	// the two players are alive?
	if ( !is_user_alive( iVictim ) || !is_user_alive( iAttacker ) )
	{
		return FMRES_IGNORED;
	}
	
	// Has the player his ultimate activated?
	if ( Player_SkillData[iAttacker][ISSEARCHING] != 1 )
	{
		return FMRES_IGNORED;
	}
	
	// You can't hit your friend :(
	if ( get_user_team( iAttacker ) == get_user_team( iVictim ) )
	{
		return FMRES_IGNORED;
	}
	
	// Check if the player has chainlightning activ
	if ( Player_Ultimate[iAttacker] == ULTIMATE_LIGHTNING )
	{
		OR_ULT_ChainLightning( iAttacker, iVictim );
	}
	
	return FMRES_IGNORED;
}

// called when a player throws a grenade
public grenade_throw( id, greindex, wID )
{
	// The player isn't alive or the grenade index is corrupt
	if ( !is_user_alive( id ) || !greindex || wID != CSW_HEGRENADE )
	{
		return PLUGIN_CONTINUE;
	}
	
	// Which color should the line have?
	static red, green, blue;
	
	// Get the right color for the right item
	if ( Player_ItemData[id][UTILMENU_ONE] == ITEM_NADEONE )
	{
		// White
		red = 255; green = 255; blue = 255;
	}
	
	else if ( Player_ItemData[id][UTILMENU_ONE] == ITEM_NADETWO )
	{
		// Blau
		red = 0; green = 0; blue = 255;
	}
	
	else if ( Player_ItemData[id][UTILMENU_ONE] == ITEM_NADETHREE )
	{
		// Red
		red = 255; green = 32; blue = 32;
	}
	
	// Draw the beamfollow (from wc3ft)
	Create_TE_BEAMFOLLOW( greindex, g_Sprites[TRAIL_SPRITE], 20, 9, red, green, blue, 196 );
	
	return PLUGIN_CONTINUE;
}
	
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1031\\ f0\\ fs16 \n\\ par }
*/
