// Sparta-Mod Motd include

public ShowMotd( id, option )
{
	if ( !is_user_connected( id ) )
	{
		return PLUGIN_HANDLED;
	}
	
	static configdir[128];
	get_configsdir( configdir, charsmax( configdir ) );
	
	switch ( option )
	{
		case 1: // Help-Motd
		{
			formatex ( configdir, charsmax( configdir ), "%s/sparta/help.htm", configdir );
			
			if ( !file_exists( configdir ) )
			{
				log_amx ( "Can't find help.htm. Please check your sparta folder" );
				
				return PLUGIN_CONTINUE;
			}
						
			// Let us show the player the motd
			show_motd ( id, configdir, "Sparta-Mod Help" );
		}
		
		case 2: // Command-Motd
		{
			formatex ( configdir, charsmax( configdir ), "%s/sparta/commands.htm", configdir );
			
			if ( !file_exists( configdir ) )
			{
				log_amx ( "Can't find commands.htm. Please check your sparta folder" );
				
				return PLUGIN_CONTINUE;
			}
			
			// Let us show the player the motd
			show_motd ( id, configdir, "Sparta-Mod Commands" );
		}
		
		case 3: // Credits-Motd
		{
			formatex ( configdir, charsmax( configdir ), "%s/sparta/credits.htm", configdir );
			
			if ( !file_exists( configdir ) )
			{
				log_amx ( "Can't find credits.htm. Please check your sparta folder" );
				
				return PLUGIN_CONTINUE;
			}
			
			// Let us show the player the motd
			show_motd ( id, configdir, "Sparta-Mod Credits" );
		}
		
		case 4: // Players on the server
		{
			ShowPlayers( id );
		}
		
		case 5: // XP Tables
		{
			ShowXPTables( id );
		}
	}
	
	return PLUGIN_CONTINUE;
}

// Show the player the XP tables
ShowXPTables( id )
{
	if ( !is_user_connected( id ) )
	{
		return PLUGIN_HANDLED;
	}
	
	// Loop through the xptable and print him all in the console
	static i;
	for ( i = 1; i < ( MAX_LEVEL + 1 ); ++i )
	{
		client_print ( id, print_console, "Level %d. %d XPs", i, g_XPforLevel[i] );
	}
	
	return PLUGIN_CONTINUE;
	
	/* 
	static i, message[4096];
	static xpmessage1[2048], xpmessage2[2048];
	copy ( xpmessage1, charsmax( xpmessage1 ), "" ); // sometimes the array's has chars init
	copy ( xpmessage2, charsmax( xpmessage2 ), "" ); // sometimes the array's has chars init
	
	// We need the header
	formatex ( message, charsmax( message ), "<html><head><style type='text/css'> .tdct { background-color: 000022; width: 300px; text-align: center; } .tdt { background-color: 220000; text-align: center; width: 300px; }</style></head><body bgcolor=#000000 text=#FFB000>^n" );
	formatex ( message, charsmax( message ), "%s<table width='600' border='0' align='center' cellpadding='0' cellspacing='0'>^n", message );
	formatex ( message, charsmax( message ), "%s<tr><td class='tdct'><strong>XP Tables</strong></td><td class='tdct'><strong>XP Tables</strong></td></tr>^n", message );
	
	for ( i = 1; i < ( MAX_LEVEL + 1 ); ++i )
	{
		if ( i <= 25 )
		{
			// We add the XP-Table to the motd
			formatex ( xpmessage1, charsmax( xpmessage1 ), "%sLevel %d. %d XPs<br>^n", xpmessage1, i, g_XPforLevel[i] );
		}
		
		else
		{
			// We need two array's because after a spezific length the motd will no more show
			formatex ( xpmessage2, charsmax( xpmessage2 ), "%sLevel %d. %d XPs<br>^n", xpmessage2, i, g_XPforLevel[i] );
		}
	}
	
	// we copy the xps in the motd message
	formatex ( message, charsmax( message ), "%s<tr><td class='tdct' style='padding-top:10px;'>%s</td><td class='tdct' style='padding-top:10px;'>%s</td></tr>^n", message, xpmessage1, xpmessage2 );
	
	// we add the end
	formatex ( message, charsmax ( message ), "%s</table></body></html>^n", message );
	
	// write it in a file
	new showplayersfile[64];
	get_configsdir( showplayersfile, charsmax( showplayersfile ) );
	
	// Format the right place
	formatex ( showplayersfile, charsmax( showplayersfile ), "%s/sparta/xptables.txt", showplayersfile );
	
	// Check if the file exists - if it exists delete it because our is newer
	if ( file_exists( showplayersfile ) )
	{
		delete_file ( showplayersfile );
	}
	
	// write the new file
	write_file ( showplayersfile, message );
	
	// show the player the motd
	show_motd ( id, showplayersfile, "XPs required for Levels" );
	
	return PLUGIN_CONTINUE;
	*/
}

// Show the player the players which are on the server
ShowPlayers( id )
{
	if ( !is_user_connected( id ) )
	{
		return PLUGIN_HANDLED;
	}
	
	// There no players so we don't have to show anything
	if ( get_playersnum() <= 1 )
	{
		client_print ( id, print_chat, "%s There no players to show", SPARTA_NAME );
		
		return PLUGIN_CONTINUE;
	}
	
	static message[4096], name[32], players[32];
	static numplayers, i, playerid; 
	
	// Get the players from the server
	get_players ( players, numplayers );
   
	// Okay, first we need the header
	formatex ( message, charsmax( message ), "<body bgcolor=#000000 text=#FFB000>^n" );
	formatex ( message, charsmax( message ), "%s<center><b>The following players are online</b></center><p>^n", message );
	formatex ( message, charsmax( message ), "%s<center><table width=800 border=1 cellpadding=4 cellspacing=4>^n", message );
	formatex ( message, charsmax( message ), "%s<tr><td>Name</td><td>Team</td><td>Level</td></tr>^n", message );

	// There we save the team
	static PlayerTeam[32];

	for ( i = 0; i < numplayers; ++i )
	{
		playerid = players[i];

		get_user_name( playerid, name, charsmax( name ) );
		
		switch ( get_user_team( playerid ) )
		{
			case TEAM_T: // Terrorists
			{
				PlayerTeam = "Terrorist";
			}
			
			case TEAM_CT: // Counterterrorists
			{
				PlayerTeam = "CT";
			}
			
			default: // Else
			{
				PlayerTeam = "Spectator";
			}
		}
		
		formatex ( message, charsmax( message ), "%s<tr><td>%s</td><td>%s</td><td>%d</td></tr>^n", message, name, PlayerTeam, Player_Level[playerid], name );
	}

	// We add the end
	formatex ( message, charsmax( message ), "%s</table></center>^n", message ); 
	
	// write it in a file
	new showplayersfile[64];
	get_configsdir( showplayersfile, charsmax( showplayersfile ) );
	
	// Format the right place
	formatex ( showplayersfile, charsmax( showplayersfile ), "%s/sparta/players.txt", showplayersfile );
	
	// Check if the file exists - if it exists delete it because our is newer
	if ( file_exists( showplayersfile ) )
	{
		delete_file ( showplayersfile );
	}
	
	// write the new file
	write_file ( showplayersfile, message );
	
	// show the player the motd
	show_motd ( id, showplayersfile, "Players on the Server" );
	
	return PLUGIN_CONTINUE;
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1031\\ f0\\ fs16 \n\\ par }
*/
