// Sparta-Mod Player options

// Get the level from a player
public GetPlayerLevel( id )
{
	// Search for the ID in the Array to find the right level
	static i;
	for ( i = 1; i < MAX_LEVEL; ++i )
	{
		// The user has gained the last level
		if ( Player_XPs[id] >= g_XPforLevel[MAX_LEVEL] )
		{
			Player_Level[id] = MAX_LEVEL;
			break;
		}
		
		// Search for the right level
		else if ( Player_XPs[id] >= g_XPforLevel[i] && Player_XPs[id] < g_XPforLevel[i+1] )
		{
			Player_Level[id] = i;
			break;
		}
	}
	
	// Can't find the level from player (maybe a higher level xps is lower than a lower level xps)
	if ( Player_Level[id] <= 0 || Player_Level[id] > MAX_LEVEL )
	{
		Player_Level[id] = 1;
	}
	return PLUGIN_CONTINUE;
}

// Get the weapon-number from the player
public GetPlayerKnife( id )
{
	static PlayerKnife;
	
	// MAX_LEVEL / MAX_KNIFES = one knife for x level
	PlayerKnife = MAX_LEVEL / MAX_KNIFES;
	
	// Player_Level[id] / oneknifeforxlevel = the knife for the level
	// Pawn integer's remove float's. That's perfect for us because the first knife is on 0
	PlayerKnife = ( Player_Level[id] - 1 ) / PlayerKnife;
	
	return PlayerKnife;
}

// We kill a player
public KillPlayer( idattacker, idvictim, teamkill, selfkill )
{
	if ( !is_user_alive( idvictim ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	// The player will die. We remove the defusekit fist of all if csdm is enabled
	if ( sp_csdm_active > 0 )
	{
		cs_set_user_defuse( idvictim, 0 );
	}
	
	static weapon[32];
	copy ( weapon, charsmax( weapon ), "knife" );
	
	switch ( selfkill )
	{
		case 1: // self kill
		{
			user_kill ( idvictim );
			return PLUGIN_CONTINUE;
		}
		
		case 2: // Ultimate Kill
		{
			copy ( weapon, charsmax( weapon ), "suicide" );
		}
		
		case 3: // From a hegrenade
		{
			copy ( weapon, charsmax( weapon ), "grenade" );
		}
	}
	
	// We should block the death message
	set_msg_block( gmsgDeathMsg, BLOCK_ONCE );
	
	// Kill Victim
	user_kill ( idvictim );
	
	// Get the frags & deaths
	static iVictimFrags, iKillerFrags, iVictimDeaths, iKillerDeaths; 
	iVictimFrags = get_user_frags( idvictim ) ;
	iKillerFrags = get_user_frags( idattacker );
	iVictimDeaths = get_user_deaths( idvictim );
	iKillerDeaths = get_user_deaths( idattacker );
	
	// is the killer a teamkiller?
	if ( teamkill )
	{
		iKillerFrags--;
	}
	
	// isn't a teamkiller
	else
	{
		iKillerFrags++;
		
		// Give the player money for the kill
		static g_CurMoney;
		g_CurMoney = cs_get_user_money( idattacker );
		if ( g_CurMoney <= 15700 )
		{
			cs_set_user_money( idattacker, ( g_CurMoney + 300 ), 1 );
		}
		
		// The money is about 15700. Set the money to 16000
		else
		{
			cs_set_user_money( idattacker, 16000, 1 );
		}
	}
	
	// We have to add one
	iVictimFrags++;
	
	// Update frags  ( realtime )
	set_user_frags( idvictim, iVictimFrags );
	set_user_frags( idattacker, iKillerFrags );
		
	// Get player teams
	static iKillerTeam, iVictimTeam;
	iKillerTeam = get_user_team( idattacker );
	iVictimTeam = get_user_team( idvictim );
	
	// Updates realtime
	Create_ScoreInfo( idattacker, iKillerFrags, iKillerDeaths, 0, iKillerTeam );
	Create_ScoreInfo( idvictim, iVictimFrags, iVictimDeaths, 0, iVictimTeam );
	
	// We create a death msg
	Create_DeathMsg_CS( idattacker, idvictim, 0, weapon );
	
	// Give him xps and some extras
	PlayerDied( idvictim, idattacker );
	
	// Remove the items
	Player_ItemData[idvictim][UTILMENU_ONE] = ITEM_NONE;
	
	return PLUGIN_CONTINUE;
}

public DoDamageToPlayer( idattacker, idvictim, dmg, TK, selfkill )
{
	// Get the health from the victim
	static VictimHealth; 
	VictimHealth = get_user_health( idvictim );
	
	// Check if the player died after this attack
	if ( VictimHealth - dmg <= 0 )
	{
		KillPlayer( idattacker, idvictim, TK, selfkill );
	}
	
	// he should not die
	else
	{
		set_user_health ( idvictim, VictimHealth - dmg );
	}
	
	return PLUGIN_CONTINUE;
}
	
	
	
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1031\\ f0\\ fs16 \n\\ par }
*/
