// Ultimate 1 - Air Flash

public AirFlash( id )
{
	id -= TASK_ULTIMATE;
	
	static origin[3], vorigin[3], distance, Float:vorigin2[3];
	static players[32], num;
	
	static i, bool:s_FoundUser;
	s_FoundUser = false;
	
	pev ( id, pev_velocity, vorigin2 );
	
	// Get the team from the ultimate owner
	static AttackerTeam;
	AttackerTeam = get_user_team( id );
	
	// Get all players
	get_players( players, num );
	
	// Loop through all players
	for ( i = 0; i < num; ++i )
	{
		// Dead player's can't get damage
		if ( !is_user_alive( players[i] ) )
		{
			continue;
		}
		
		// We need all players from the opposite team
		if ( get_user_team( players[i] ) == AttackerTeam )
		{
			continue;
		}
		
		// Get the origin from the enemy
		get_user_origin ( players[i], vorigin );
		
		// Origin from the player
		get_user_origin ( id, origin );
		
		// Get the distance
		distance = get_distance ( origin, vorigin );
		
		if ( distance < AF_RADIUS )
		{
			// only one time
			if ( !s_FoundUser )
			{
				// Handle the icon
				HandleIcon( id, 0 );
				
				// We found someone, ultimate start and he gets a cooldown
				Player_UltDelay[id] = get_pcvar_num( sp_ultdelay );
			
				// Play the sparta sound (THIS IS SPARTA!)
				if ( get_pcvar_num( sp_soundon ) )
				{
					emit_sound( id, CHAN_STATIC, g_Sound[THIS_IS_SPARTA_SOUND], 1.0, ATTN_NORM, 0, PITCH_NORM );
				}
				
				set_task ( 0.1, "Play_FlashSound", ( id + TASK_ULT_SOUND ) );
				
				s_FoundUser = true;
			}
			
			// He should look to the ultimate owner
			entity_set_aim ( players[i], vorigin2, 0 );
			
			// The sparta sound is over, now we can flash him
			set_task ( 0.1, "Flash_Enemy", ( players[i] + TASK_ULT_FLASH ) );
		}
	}
	
	// We didn't found a player in range, let us say it to him
	if ( !s_FoundUser )
	{
		UltErrorMessages( id, 3 );
	}
	
	return PLUGIN_HANDLED;
}

// Flash the enemy
public Flash_Enemy( id )
{
	id -= TASK_ULT_FLASH;
	
	if ( !is_user_alive ( id ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	// Flash the player
	Create_ScreenFade( id, (9<<15), (9<<10), (5<<12), 255, 255, 255, 255 );
	
	return PLUGIN_CONTINUE;
}

// Play a flash sound
public Play_FlashSound( id )
{
	id -= TASK_ULT_SOUND;
	
	if ( !is_user_alive( id ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	emit_sound ( id, CHAN_STATIC, g_Sound[FLASHBANG_SOUND], 1.0, ATTN_NORM, 0, PITCH_NORM );
	
	return PLUGIN_CONTINUE;
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1031\\ f0\\ fs16 \n\\ par }
*/
