// Ultimate 2 - Napalm Attack

public NapalmAttack( id )
{
	id -= TASK_ULTIMATE;
	
	static origin[3], vorigin[3], distance;
	static players[32], num;
	
	static i, bool:s_FoundUser, parm2[2];
	s_FoundUser = false;
	
	static parm[2], AttackerTeam;
	
	// Get the team from the ultimate owner
	AttackerTeam = get_user_team( id );
	
	// Get all players
	get_players( players, num );
	
	for ( i = 0; i < num; ++i )
	{
		// Dead player's can't get damage
		if ( !is_user_alive( players[i] ) )
		{
			continue;
		}
		
		// We need all players from the opposite team
		if ( get_user_team( players[i] ) == AttackerTeam )
		{
			continue;
		}
		
		// Get the origin
		get_user_origin ( players[i], vorigin );
		
		// Origin from the player
		get_user_origin ( id, origin );
		
		// Get the distance
		distance = get_distance ( origin, vorigin );
		
		if ( distance < NA_RADIUS )
		{
			// only one time
			if ( !s_FoundUser )
			{
				// Play the sparta sound (THIS IS SPARTA!)
				if ( get_pcvar_num( sp_soundon ) )
				{
					emit_sound( id, CHAN_STATIC, g_Sound[THIS_IS_SPARTA_SOUND], 1.0, ATTN_NORM, 0, PITCH_NORM );
				}
				
				// Create an implosion
				set_task ( 0.1, "CreateImplosion", ( id + TASK_ULT_IMP ) );
				
				// Create the explosion
				parm2[0] = id;
				parm2[1] = 6;
				set_task ( 0.5, "CreateExplosion", ( id + TASK_ULT_NAPALM ), parm2, 2 );
				
				// Ok now we can draw the blast circles
				set_task ( 0.5, "BlastCircles", ( TASK_ULT_CIRCLES + id ) );
				
				// Handle the icon
				HandleIcon( id, 0 );
				
				// We found someone, ultimate start and he get a cooldown
				Player_UltDelay[id] = get_pcvar_num( sp_ultdelay );
						
				s_FoundUser = true;
			}
			
			// save the ids in a array
			parm[0] = id;
			parm[1] = players[i];
			
			// The sparta sound is over, now we can explode him 
			set_task ( 0.1, "DealVictims", ( players[i] + TASK_ULT_NAPALM ), parm, 2 );
		}
	}
	
	// We didn't found a player in range, let us say it to him
	if ( !s_FoundUser )
	{
		UltErrorMessages( id, 3 );
	}
	
	return PLUGIN_HANDLED;
}

// Create a implosion
public CreateImplosion( id )
{
	id -= TASK_ULT_IMP;
	
	if ( !is_user_alive( id ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	static origin[3];
	get_user_origin ( id, origin );
	
	// Create an implosion
	Create_TE_IMPLOSION( origin, 100, 20, 5 );
	
	return PLUGIN_CONTINUE;
}

// Create a explosion
public CreateExplosion ( parm[2] )
{
	new id = parm[0];
	
	if ( !is_user_alive( id ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	// Explosion sound
	emit_sound( id, CHAN_STATIC, g_Sound[EXPLOSION_SOUND], 1.0, ATTN_NORM, 0, PITCH_NORM );
	
	new origin[3];
	get_user_origin ( id, origin );
	
	// Calculate the explode position
	new vPosition[3];
	vPosition[0] = origin[0] + random_num( -100, 100 );
	vPosition[1] = origin[1] + random_num( -100, 100 );
	vPosition[2] = origin[2] + random_num( -50, 50 );
	
	// Create the explosion
	Create_TE_EXPLOSION( origin, vPosition, g_Sprites[EXPLOSION_SPRITE], (random_num(0,20) + 20), 12, 0 );
	
	// Create the smoke 
	Create_TE_Smoke( origin, vPosition, g_Sprites[SMOKE_SPRITE], 60, 10 );
	
	// We have to take one
	parm[1]--;
	
	// We have to do it 6 times
	if ( parm[1] > 0 )
	{
		set_task ( 0.1, "CreateExplosion", ( id + TASK_ULT_NAPALM ), parm, 2 );
	}
	
	return PLUGIN_CONTINUE;
}

// Draw the blast circles from wc3ft
public BlastCircles( id )
{
	id -= TASK_ULT_CIRCLES;
	
	new vOrigin[3], vPosition[3];
	
	get_user_origin ( id, vOrigin );

	vPosition[0] = vOrigin[0];
	vPosition[1] = vOrigin[1];
	vPosition[2] = vOrigin[2] + NA_RADIUS;

	Create_TE_BEAMCYLINDER( vOrigin, vOrigin, vPosition, g_Sprites[SHOCKWAVE_SPRITE], 0, 0, 6, 16, 0, 188, 220, 255, 255, 0 );

	vOrigin[2] = ( vOrigin[2] - NA_RADIUS ) + ( NA_RADIUS / 2 );

	Create_TE_BEAMCYLINDER( vOrigin, vOrigin, vPosition, g_Sprites[SHOCKWAVE_SPRITE], 0, 0, 6, 16, 0, 188, 220, 255, 255, 0 );
}

// Set some settings to the player
public DealVictims( parm[2] )
{
	// Get the ids back
	static id, UltAttacker;
	UltAttacker = parm[0];
	id = parm[1];
	
	if ( !is_user_alive ( id ) || !is_user_alive( UltAttacker ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	// Shake their screens
	Create_ScreenShake( id, (1<<14), (1<<13), (1<<14) );
	
	// Deal some damage
	DoDamageToPlayer ( UltAttacker, id, NA_DAMAGE, 0, 2 );
	
	return PLUGIN_CONTINUE;
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1031\\ f0\\ fs16 \n\\ par }
*/
